package lbi.file.format;

import java.io.BufferedReader;
import java.io.IOException;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import lbi.utils.Cronos;
import lbi.utils.IOUtil;

public class CSV2JSON {

     @SuppressWarnings("unchecked")
	public static void main(String[] args) throws IOException {
        if (args.length != 1) {
            System.out.println(
                    "Usage: java CSV2JSON inputFile");
            System.exit(0);
        }
    	Cronos t = new Cronos();
    	t.start();
    	JSONArray table = new JSONArray();
        BufferedReader input = IOUtil.getReader(args[0]);
        String[] columns = IOUtil.readTokens(input);
        String[] tokens;
        while ((tokens = IOUtil.readTokens(input)) != null) {
        	JSONObject row = new JSONObject();
        	for(int i=0; i<columns.length; ++i) {
                try {
	        		row.put(columns[i], Double.parseDouble(tokens[i]));
                } catch (NumberFormatException e) {
	        		row.put(columns[i], tokens[i]);
                }
        	}
        	table.add(row);
        }
        input.close();
        t.stop();
        System.out.println("JSON: " + table);
	}

}
