package lbi.file.format;

import java.util.*;

//  column type
class CType {
	// threshold from enumerated to string/real
    static private final int MAX_ENUMERATED = 9;
    // only numeric values?
    private boolean isNumeric;
    // distinct values seen so far
    private TreeSet<String> distinctValues;
    // init
    public CType() {
    	isNumeric = true;
    	distinctValues = new TreeSet<String>();
    }
    // isNumeric
    private static boolean isNumber(String newelement) {
        try {
            Double.parseDouble(newelement);
            return true;
        } catch (NumberFormatException e) {
            return false;
        }
    }
    // update type after reading a new value
    public void updateType(String newvalue) {
    	if( newvalue.equals("?") ) // skip missing values
    		return;
    	isNumeric = isNumeric && isNumber(newvalue);
    	if( distinctValues.size() <= MAX_ENUMERATED)
    		distinctValues.add(newvalue); 
    }
    // get type given the current state
    public String getType() {
    	if( distinctValues.size() > MAX_ENUMERATED)
            return isNumeric ? "real" : "string";
    	// enumerated - construct string
        String res = "{";
        boolean first = true;
        for(String s : distinctValues) {
        	if( first )
        		first = false;
        	else
        		res += ",";
        	res += s;
        }
        res += "}";
        return res;
    }
}
